<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!-- NOTE: Follow the steps in documentation/getting_started.html. -->
<!--       Also see http://code.google.com/p/nativeclient.         -->
<!--                                                               -->
<!-- The latest version of this file is viewable online at:        -->
<!-- http://nativeclient.googlecode.com/svn/trunk/nacl/googleclient/native_client/README.html                                                      -->

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Native Client: README</title>
<link href="documentation/stylesheet.css" type="text/css" rel="stylesheet"></link>
</head>

<body>

<!-- start: CSE gadget -->
<div style="padding-top:5px; padding-bottom:5px; align:right; float: right;">
<form action="http://www.google.com/cse" id="cse-search-box" target="_blank">
<div>
<input type="hidden" name="cx" value="002967670403910741006:qhab5lo7cqo" />
<input type="hidden" name="ie" value="UTF-8" />
<input type="text" name="q" size="28" />
<input type="submit" name="sa" value="Search" />
<div style="font-size:75%">
Search Native Client webpages
</div>
</div>
</form>
<script type="text/javascript" src="http://www.google.com/coop/cse/brand?form=cse-search-box&amp;lang=en"></script>
<script>_IG_AdjustIFrameHeight();</script>
</div>
<!-- end: CSE gadget -->

<h1><a name="NativeClient_Documentation_trust" id="NativeClient_Documentation_trust"> </a> Native Client: README </h1>

<p>
Welcome to the Native Client distribution.
This README file has the following sections:
</p>

<ul>
<li><a href="#doc">Documentation</a></li>
<li><a href="#directory">Directory structure</a></li>
</ul>

<p>
For the latest information about Native Client, see the
<a href="http://code.google.com/p/nativeclient">Native Client project page</a>.
</p>


<h2><a name="doc" id="doc"> </a> Documentation </h2>
<p> This release of Native Client contains the following documentation: </p>
<ul>
  <li> How tos
    <ul>
        <li> <a href="documentation/getting_started.html">Getting Started</a>
        - A guide to running example modules and building your own </li>
      <li> <a href="documentation/building.html">Building Native Client</a>
      - How to build Native Client, including its demos and tests </li>
      <li> <a href="documentation/debugging.html">Debugging Tips</a>
      - How to debug your Native Client modules </li>
    </ul>
  </li>
  <li> APIs
    <ul>
        <li> <a href="scons-out/doc/html/index.html">API Reference</a>
        - Automatically generated reference documentation for
        APIs defined by Native Client </li>
        <li> <a href="documentation/npapi.html">NPAPI Support</a>
         - Information about which NPAPI functions are supported
           for use in Native Client modules </li>
    </ul>
  </li>
  <li> And more
    <ul>
      <li> <a href="documentation/examples.html">Examples and Tests</a> - A guide to our sample Native Client modules </li>
      <li> <a href="documentation/nacl_paper.pdf">Native Client: A Sandbox for Portable, Untrusted x86 Native Code</a> [PDF]
      - A research paper about the design, implementation, and evaluation of Native Client</li>
      <li> Platform-specific details for
        <a href="documentation/platform-linux.html">Linux</a>,
        <a href="documentation/platform-mac.html">Mac</a>, and
        <a href="documentation/platform-windows.html">Windows</a>. </li>

    </ul>
  </li>
</ul>


<h2><a name="directory" id="directory"> </a> Directory structure </h2>

<p>
The distribution for each platform (Linux, Mac, or Windows)
contains the following:
</p>

<ul>
  <li> A pre-built SDK for that platform </li>
  <li> Pre-built binaries for the Firefox plug-in,
       the <code>sel_ldr</code> test container,
       and a set of example and test programs</li>
  <li> Complete, buildable source
       that's portable across all three operating systems</li>
  <li> Documentation, including the
       <a href="documentation/getting_started.html">Getting Started</a> guide
       </li>
</ul>

<p>
Although the documentation is incomplete,
you should be able to find what you need by looking at the the source code.
The following table describes major files and directories
in the release.
Paths are relative to the
<code>nacl/googleclient/native_client</code> directory.
</p>

<table>
  <tbody>
    <tr>
      <th>File or directory</th>
      <th>Description</th>
    </tr>
    <tr>
      <td><pre class="listing">
<a href="../VERSION">../VERSION</a>
<a href="COPYING">COPYING</a>
<a href="NOTICE">NOTICE</a>
README.html <em>(this file)</em>
<a href="RELEASE_NOTES">RELEASE_NOTES</a>
<a href="./documentation/">documentation/</a>
</pre></td>
      <td>Documentation, release, and license information.</td>
    </tr>
    <tr>
      <td><pre class="listing">
<a href="./common/">common/</a>
<a href="./tests/">tests/</a>
</pre></td>
      <td> Source code for <a href="documentation/examples.html">examples and tests</a>. </td>
    </tr>

    <tr>
      <td><pre class="listing">
SConstruct
scons.bat
scons
<a href="./scons-out/">scons-out/</a>
<a href="./site_scons/">site_scons/</a>
</pre></td>
      <td><p>Build-related files. In each tarball, <code>scons-out/*/staging</code> directories contain files that let you use and test the Native Client plug-in. The <code>scons.bat</code> and <code>scons</code> files let you  <a href="documentation/building.html">build</a> Native Client,
           examples, and tests.</p>      </td>
    </tr>

    <tr>
      <td><pre class="listing">
<a href="./include/">include/</a>
<a href="./intermodule_comm/">intermodule_comm/</a>
<a href="./ncv/">ncv/</a>
<a href="./nonnacl_util/">nonnacl_util/</a>
<a href="./npapi_plugin/">npapi_plugin/</a>
<a href="./service_runtime/">service_runtime/</a>
</pre></td>
      <td>Core source code.
        <code>include</code> contains header files
        that are missing from some platforms
        and are used by more than one major module.
        <code>intermodule_comm</code> implements the lower-level abstractions
        of the IMC interface.
        <code>ncv</code> implements the validator.
        <code>nonnacl_util</code> contains utilities
          used by by the plug-in to launch <code>sel_ldr</code>.
        <code>npapi_plugin</code> is the Native Client plug-in.
        <code>service_runtime</code> is the core of Native Client. </td>
    </tr>
    <tr>
      <td><pre class="listing">
<a href="./gtest/">gtest/</a>
</pre></td>
      <td>Google open source unit testing framework,
      used for <code>service_runtime</code> unit tests.
    </tr>
    <tr>
      <td><pre class="listing">
<a href="./platform_qual_test/">platform_qual_test/</a>
</pre></td>
      <td>Platform Qualification Test V0.1.
          Used by <code>sel_ldr</code>
          to verify that the current machine and OS
          meet the minimum requirements
          for running Native Client modules.
      </td>
    </tr>
    <tr>
      <td><pre class="listing">
<a href="../third_party/">../third_party/</a>
<a href="./third_party/">third_party/</a>
</pre></td>
      <td>Third-party source code and
      (in <a href="../third_party/nacl_sdk/"><code>../third_party/nacl_sdk/</code></a>)
      a pre-built Native Client SDK.</td>
    </tr>

    <tr>
      <td><pre class="listing">
<a href="./tools/">tools/</a>
</pre></td>
      <td> Source code for the Native Client SDK.</td>
    </tr>

  </tbody>
</table>

<p id="license">
Except as otherwise
<a href="http://code.google.com/policies.html#restrictions">noted</a>,
the content of this page is licensed under a
<a href="http://www.google.com/url?sa=D&amp;q=http%3A%2F%2Fcreativecommons.org/licenses/by/2.5/">Creative Commons
Attribution 2.5 license</a>.
</p>

</body>
</html>
